\setchapterstyle{kao}
\chapter{ARM Embedded Systems}

Increasingly, embedded systems and system-on-chip designers select specific microprocessor cores and a family of tools, libraries,
and off-the-shelf components to quickly develop new microprocessor-based products. A major player in this industry is ARM.

One of ARM's most successful cores is the ARM7TDMI. It is known for its high code density and low power consumption, making it ideal
for mobile embedded deveices.

In this chapter, we discuss how the RISC \marginnote{RISC stands for reduced instruction set computer.} design philosophy was adpated 
by ARM to create a flexible embedded processor. We then introduce an example embedded device and discuss the typical hardware and
software technologies that surround an ARM processor.

\section{The RISC Design Philosophy}

The ARM core uses a RISC architecture.

\begin{kaobox}[frametitle=RISC]
    \begin{itemize}
        \item Aimed at delivering simple but powerful instructions that execute within \emph{a single cycle at a high clock speed};
        \item Concentrates on reducing the complexity of instructions performed by the hardware because it is easier to provide 
        greater flexibility and intelligence in software rather than hardware;
        \item As a result, places greater demands on the compiler.
        \marginnote{RISC contrasts the traditional complex instruction set computer (CISC) which relies more on the hardware for 
        instruction functionality.}
    \end{itemize}
\end{kaobox}

The RISC philosophy is implemented with four major design rules:


\subsection*{Instructions}
\begin{itemize}
    \item RISC processors have a reduced number of instruction classes.
    \item Each class provides simple operations that can execute in a single cycle.
    \item The compiler or programmer synthesizes complicated operations (for example, a divide operation) by combining
    several simple instructions.
    \item Each instruction is a fixed length to allow the pipeline to fetch future instructions before deconding the current 
    instruction. \marginnote{In CISC processors the instructions are often of variable size and take many cycles to
    execute.}
\end{itemize}
    
\subsection*{Pipelines} 
The processing of instructions is broken down into smaller units that can executed \emph{in parallel} by pipelines.
Ideally, the pipeline advances by one step on each cycle for maximum throughput. Instructions can be decoded in one \emph{pipeline 
stage}. \marginnote{There is no need for an instruction to be executed by a miniprogram called microcode as on CISC processors.}

\subsection*{Registers} 
RISC machines have a large general-purpose register set. Any register can contain either data or an address.
Registers act as the \emph{fast local memory store} for all data processing operations. \marginnote{In contrast, CISC processors
have dedicated registers for specific purposes.}
    
\subsection*{Load-Store Architecture} 
The processor operates on data held in registers. Separate load and store instructions transfer data
between the \emph{register bank} and \emph{external memory}. However, \emph{memory addresses are costly}! Therefore, separating
memory accesses from data processing provides an advantage because you can use data items held in the register bank multiple times
without need multiple memory accesses.\marginnote{With a CISC design, the data processing operations can act on memory directly.}

These design rules allow a RISC processor to be simpler, and thus the core can oeprate at higher clock frequencies. In contrast, 
traditional CISC processors are more complex and operate at lower clock frequencies. Today, however, the distinction between RISC and
CISC has blurred as CISC processors have implemented more RISC concepts.

\section{The ARM Design Philosophy}

The ARM processor has been specifically designed
\begin{itemize}
    \item to be small to \emph{reduce power consumption} and extend battery operation;
    \item for \emph{high code density}, which is useful for applications that have limited on-board memory;
    \item to be \emph{low-cost} for high-volume applications, opting for slower memory in exchange for substantial savings;
    \item to \emph{reduce die area} for fewer discrete chips and more space for specifialized peripherals. 
\end{itemize}

The ARM core is not a pure RISC architecture because of the constraints of its primary application-- the embedded system.

\section{Embedded System Hardware}

In an embedded system, each component is chosen for efficiency and, if applicable, is designed for future expansion. We can
separate the device into \emph{four main hardware components}.

\subsection*{ARM processor}
\begin{itemize}
    \item Controls the embedded device.
    \item Comprises of a \emph{core}: the execution engine that processes instructions and manipulates data
    \item Comprises of surrounding components that interface it with a \emph{bus}. These components can include memory
    management and caches.
\end{itemize}
    
\subsection*{Controllers} 
Controllers coordinate important functional blocks of the system. Two commonly found controllers are the
\emph{interrupt controller} and the \emph{memory controller}.

\subsection*{Peripherals} 
Peripherals provide all the input-output capability external to the chip and are responsible for the 
uniqueness of the embedded device.

\subsection*{Bus} 
Buses are used to communicate between different parts of the device.

\section{ARM Bus Technology}

Embedded devices use an on-chip bus that is internal to the chip and that allows different peripherals to be interconnected
with an ARM core. There are two different classes of devices attached ot the bus. The ARM processor core is a 
\emph{bus master}, whereas peripherals tend to be bus slaves. \marginnote{\emph{bus master}: a logical device capable of 
\emph{initiating} a data transfer with another device across the same bus \\ \emph{bus slave}: a logical device capable 
only of \emph{responding} to a transfer request from a bus master device.}

A bus has two architecture levels. 
\begin{itemize}
    \item A physical level that covers the electrical characteristics and a bus width (16, 32, 64 bits, and higher)
    \marginnote{ARM is primarily a design company. It seldom implements the electrical characterisitcs of the bus, but it
    routinely specifies the bus protocol.}
    \item A logical level that deals with \emph{protocol}: the rules that govern the communication between the processor
    and a peripheral.
\end{itemize}

\section{Memory}


